DEFINE VARIABLE r1_rowid AS ROWID NO-UNDO.
DEFINE VARIABLE r2_rowid AS ROWID NO-UNDO.
DEFINE VARIABLE c1_rowid AS CHARACTER NO-UNDO.
DEFINE VARIABLE c2_rowid AS CHARACTER NO-UNDO.

/* let the user type in a customer2: */ 
PROMPT-FOR customer.unique2.

/* search the customer table in db: */
FIND customer USING unique2 NO-LOCK.

/* display customer's name: */
DISPLAY customer.name WITH SIDE-LABELS.

/* obtain the rowid of the record (if any): */
r1_rowid = ROWID(customer).
DISPLAY STRING(r1_rowid) SKIP(2) WITH SIDE-LABELS.

/* display it in user-readable format: */
c1_rowid = STRING(r1_rowid).
DISPLAY c1_rowid SKIP WITH SIDE-LABELS.

/* reverse conversion */
r2_rowid = TO-ROWID(c1_rowid).
DISPLAY STRING(r2_rowid) (r1_rowid = r2_rowid) SKIP
      WITH SIDE-LABELS. /* assert(r1_rowid == r2_rowid) */

/* reverse verification: */
c2_rowid = STRING(r2_rowid).
DISPLAY c2_rowid (c1_rowid = c2_rowid) SKIP(2)
      WITH SIDE-LABELS. /* assert(c1_rowid == c2_rowid) */

/* other test cases: */
DISPLAY "Other test cases:" SKIP.
DISPLAY 
   "Should be invalid: " STRING(TO-ROWID("0x1")) SKIP
   "Should be valid: "   STRING(TO-ROWID("0x01")) SKIP
   "Should be invalid: " STRING(TO-ROWID("0X01")) SKIP
   "Should be invalid: " STRING(TO-ROWID("0x0A")) SKIP
   "Should be valid: "   STRING(TO-ROWID("0x1a")) SKIP
   "Should be valid: "   STRING(TO-ROWID("0x1234abcd")) SKIP
   "Should be invalid: " STRING(TO-ROWID("0xffffff0")) SKIP
   "Should be invalid: " STRING(TO-ROWID("0x00ffffff0")) SKIP
   "Should be valid: "   STRING(TO-ROWID("0x01ef")) SKIP
   "Should be valid: "   STRING(TO-ROWID("0xffffff")) SKIP
   "Should be invalid: " STRING(TO-ROWID("0x1000000")) SKIP
   "Should be invalid: " STRING(TO-ROWID("0xbadrow")) SKIP
   "Should be invalid: " STRING(TO-ROWID("badrow")) SKIP WITH SIDE-LABELS.
DISPLAY 
   "Should throw exception: " STRING(TO-ROWID("0x123456abcd")) 
                                                    SKIP WITH SIDE-LABELS.

PAUSE.
/* end of test program */
